/*
    This file is part of COMMON AVR UTILS.

    COMMON AVR UTILS is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License (LGPL)
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    COMMON AVR UTILS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License at <http://www.gnu.org/licenses/>
    for more details.

    (C) Georg-Johann Lay <georgjohann@web.de>
*/

#ifndef DIV_H
#define DIV_H

#include <stdint.h>

typedef struct
{
	uint16_t quot;
	uint16_t rem;
} udiv_t;

typedef struct
{
	uint8_t quot;
	uint8_t rem;
} udiv8_t;

typedef struct
{
	uint32_t quot;
	uint32_t rem;
} udiv32_t;

extern udiv_t udiv (uint16_t, uint16_t)  __asm__("__udivmodhi4") __attribute__ ((const));

extern udiv8_t udiv8 (uint8_t, uint8_t) __asm__("__udivmodqi4") __attribute__ ((const));
extern udiv32_t udiv32 (uint32_t, uint32_t) __asm__("__udivmodsi4") __attribute__ ((const));


#endif /* DIV_H */
