#ifndef BEAM_FUNCS_H_
#define BEAM_FUNCS_H

#include "flags.h"
#include "pixel.h"
#include "reload.h"

#if !defined __AVR__
extern upixel8_t reg_pixel;
#else // AVR
#   define REG_PIXEL "6"
register upixel8_t reg_pixel asm (REG_PIXEL);

#define beam_skip()                                 \
    do                                              \
    {                                               \
        FLAGS |= BEAM_SKIP;                         \
    } while (0) 
    
#define VECFONT_BEAM_SKIP()                         \
    do                                              \
    {                                               \
        RELOAD ("y", vf);                           \
        FLAGS |= BEAM_SKIP;                         \
    } while (0) 
    
#define beam_xy(X,Y)                                \
    do                                              \
    {                                               \
        reg_pixel.x = X;                            \
        reg_pixel.y = Y;                            \
        FLAGS |= BEAM_CHANGED;                      \
    } while(0)
    
#define VECFONT_BEAM_XY(X,Y)                        \
    do                                              \
    {                                               \
        RELOAD ("y", vf);                           \
        reg_pixel.x = X;                            \
        reg_pixel.y = Y;                            \
        FLAGS |= BEAM_CHANGED;                      \
    } while(0)
    
#define beam_join() \
        FLAGS &= ~BEAM_SKIP
        
#define BRESENHAM_BEAM_XY   beam_xy
#define BRESENHAM_BEAM_SKIP beam_skip

#endif // AVR

#endif /* BEAM_FUNCS_H */

