#ifndef FLAGS_H
#define FLAGS_H

#if defined __AVR__
#include <avr/io.h>
#else // !AVR
#include <inttypes.h>
extern uint8_t volatile GPIOR0;
#endif // AVR

#define FLAGS GPIOR0

#define FRAME_ISR_NEW   (1<<0)
#define BEAM_CHANGED    (1<<1)
#define FRAME_LOCKED    (1<<2)
#define FRAME_VALID     (1<<3)
#define BEAM_TILT       (1<<4)
#define BEAM_GET_PIXEL  (1<<5)
// WARNUNG: BEAM_SKIP ist nur Alias fr BEAM_GET_PIXEL!
#define BEAM_SKIP       (1<<5)

// Avoid some braindead "optimization"
#define IS_FLAG(X) \
    ({ unsigned char __flag = FLAGS & X; __flag;})
#endif // FLAGS_H
