
#include <stdint.h>

#ifdef __i386__
#include <math.h>

#endif

#if 0
#include "compat/pgmspace.h"

#include "wire.h"

typedef struct
{
    uint16_t t_max;
    uint8_t data[];
} line_t;

const line_t data_A =
{
	.t_max = 631,	// t in [0, 0.87649288 * 2*Pi]
	{
		FRAC8 (0.197),	// x0
		5,	// Anzahl x-Terme
		FRAC8 (0.440),   25, 2,	// A * sin (1*t + phi), phi =  0.7471 * 2*Pi
		FRAC8 (0.439),  102, 1,	// A * sin (2*t + phi), phi =  0.4974 * 2*Pi
		FRAC8 (0.365),  165, 1,	// A * sin (3*t + phi), phi =  0.5847 * 2*Pi
		FRAC8 (0.197),   38, 2,	// A * sin (4*t + phi), phi =  0.7645 * 2*Pi
		FRAC8 (0.087),   64, 2,	// A * sin (5*t + phi), phi =  0.8012 * 2*Pi
	
		FRAC8 (-0.191),	// y0
		3,	// Anzahl y-Terme
		FRAC8 (0.232),  152, 2,	// A * sin (1*t + phi), phi =  0.9228 * 2*Pi
		FRAC8 (0.467),  241, 1,	// A * sin (2*t + phi), phi =  0.6905 * 2*Pi
		FRAC8 (0.459),  244, 0	// A * sin (3*t + phi), phi =  0.3392 * 2*Pi
	}
};

uint16_t foo (uint16_t t)
{
    uint8_t n;
    uint16_t x;
    
    const uint8_t * data = (const uint8_t*) & data_A;
    
    data += 2;
    
    x = *data++;
    n = *data++;
    
    x <<= 8;
    
    uint16_t kt = t;
    
    while (1)
    {
        uint8_t A   = *data++;
        uint8_t phi8 = *data++;
        uint16_t phi = (uint16_t) 3*phi8;
        
        phi += kt;
        if (phi >= 720)    phi -= 720;
        
        uint8_t si = _i_get_sin8 (phi);
        
        fmac8_16 (x, A, si);
        
        if (n-- == 0)
            break;
            
        kt += t;
        if (kt >= 720)   kt -= 720;
    } 
    
    return x;
}
#endif 

/*
// <-- header start -->
typedef enum
{
    STATE0,
    STATE1,
    
    STATE_NUM
}  state_t;

typedef state_t (*statehandler_t)(void);

extern state_t handler0 (void);
extern state_t handler1 (void);

// <-- header end -->
statehandler_t handler[] = 
{
    handler0,
    handler1
};

void main_loop (void)
{
    state_t state = STATE0;
    
    while (1)
    {
        statehandler_t thehandler = handler[state];
        state = thehandler ();
    }
}

*/

//typedef int (*) (*state_handler_t)(state_t*);

/*
int * (*sta)(void);

int (*bar)(char);

int foo (char x)
{
    return x;
}

typedef int (*bar_t)(char);

bar_t bar2 = foo;

//typedef int (foob_t*
int (*foobar (void))(char)
{
    return bar;
}

void bazz(void)
{
    bar2 = bar;
    bar = foo;
}
*/
/*
state_handler_t state_handler[] = 
{
};
*/


// unsigned saturated addition, 8 bit

/*
int barr (int i)
{
    asm volatile (";\;nn" : "+r,r" (i));
    return i;
}
static inline uint8_t usadd8 (uint8_t a, uint8_t b)
{
    return __builtin_choose_expr (__builtin_constant_p (b),
        
    ({
        asm  ("subi %0, %n1" "\n\t"
              "brcs 0f"      "\n\t"
              "ldi %0, 255"  "\n\t"
              "0:"
              : "+d" (a)
              : "n" (b));
              a;
    })
    , ({
        asm  ("add %0, %1"  "\n\t"
              "brcc 0f"     "\n\t"
              "ldi %0, 255" "\n\t"
              "0:"
              : "+d" (a)
              : "r" (b));
              a;
    }));
}
*/


#if 0

#include "data-types.h"
int16_t sqrt4_12 (uint16_t r)
{
    uint16_t sq = 0;
    
    data16_t m = {.asWord = (1 << (12 + 1))}; // r <= 8 --> sqrt(r) < 3

    do
    {
        sq += m.asWord;
        
        uint16_t m10 = m.asByte[1] * m.asByte[0];
        
        data32_t m2 = {.asWord = {[0] = (uint16_t) (m.asByte[0] * m.asByte[0]),
                                  [1] = (uint16_t) (m.asByte[1] * m.asByte[1])}};
#ifndef __AVR__                                  
        uint16_t tmp;
        
        tmp = m2.bytes12; m2.bytes12 += m10; if (m2.bytes12 < tmp) m2.byte3++;
        tmp = m2.bytes12; m2.bytes12 += m10; if (m2.bytes12 < tmp) m2.byte3++;
#else
        asm ("add %B0, %A1" "\n\t"
             "adc %C0, %B1" "\n\t"
             "adc %D0, __zero_reg__" "\n\t"
             "add %B0, %A1" "\n\t"
             "adc %C0, %B1" "\n\t"
             "adc %D0, __zero_reg__"
            : "+r" (m2) 
            : "r" (m10));        
#endif        
        
        m2.asULong >>= 4;

        // m^2 in m2.12    
        if (m2.bytes12 > r)
            return sq -= m.asWord;
        m.asWord >>= 1;
    } while (m.asWord);
    
    return sq;
}



#endif // 0

#ifndef __AVR__

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

static inline int ggT2 (int a, int b)
{
    return b ? ggT (b, a % b) : a;
}

int main()
{
    int a = 18;
    int b = 24;
    
    return ggT (a,b);
}

#endif
