#ifndef PORTS_H
#define PORTS_H

#if defined __AVR__
#   include <avr/io.h>
#   include "avr-port-macros.h"
#   include "avr-port-enum.h"
#else
#   include "avr-port-enum.h"
extern void SET (int);
extern void CLR (int);
extern void TOGGLE (int);
#endif

/*************************************
 ** MORPHEUS **
 *************************************/
enum
{
    PORT_POWER    = PORTD_6,
    PORT_DREHTAST = PORTB_3, // MOSI
    PORT_DREHA    = PORTB_0,
    PORT_DREHB    = PORTD_7,
    
	PORT_Z    = PORTD_4,
    
	PORT_DAC0 = PORTC_0,
	PORT_DAC1 = PORTC_1,
	PORT_DAC2 = PORTC_2,
	PORT_DAC3 = PORTC_3,
	PORT_DAC4 = PORTC_4,
	PORT_DAC5 = PORTC_5,
	PORT_DAC6 = PORTB_5, // SCK
	PORT_DAC7 = PORTB_4, // MISO
    
    PORT_DAC_CS = PORTD_2, // 0=Enable
    PORT_DAC_AB = PORTD_3, // 0=A, 1=B
    PORT_LED    = PORTD_3, // DAC A/B
    
    PORT_RxD = PORTD_0,
    PORT_TxD = PORTD_1,
	PORT_IR  = PORTD_5,
    
    PORT_SPKA = PORTB_1,
    PORT_SPKB = PORTB_2,

    PORT_DCF = PORT_RxD,
    
	PORT_NIL
};

#endif /* PORTS_H */
