#include "time.h"

#include "div.h"

time_t time;

void 
timeid_add (time_t * ti, short inc)
{
    long tid = ti->timeid + inc;
    
    do tid -= TIMEID_MAX; while (tid >= 0);
    while (tid < 0)              tid += TIMEID_MAX;
    
    ti->timeid = tid;
    ///////////////////////////////////
    
    unsigned short z16 = tid;
    
    udiv_t qrem = udiv (z16, 60);

    ti->second = qrem.rem;
    
    qrem = udiv (qrem.quot, 60);

    ti->hour   = qrem.quot;
    ti->minute = qrem.rem;
    
    ti->changed.second = 1;
}


#if 0
static const prog_uint8_t time_max[] =
{
	60, // Sekunden / Minute
	60, // Minuten  / Stunde
	24, // Stunden  / Tag
	7,  // Tage     / Woche
	0
};

void 
next_second (time_t *ptime)
{
	uint8_t *ti = ptime->b;
	const prog_uint8_t *pmax = time_max;
	
	RELOAD ("z", pmax);

	uint8_t t;

	do
	{
		uint8_t max = pgm_read_byte_inc (pmax);
		
		if (!max)
			break;

		t = 1 + *ti;
		if (t == max)
			t = 0;

		*(ti++) = t;
	}
	while (t == 0);
}

void 
prev_second (time_t *ptime)
{
	uint8_t *ti = ptime->b;
	const prog_uint8_t *pmax = time_max;
	
	RELOAD ("z", pmax);

	uint8_t max;
	uint8_t t;
	
	do
	{
		max = pgm_read_byte_inc (pmax);		
		
		if (0 == max)
			break;
			
		max--;

		t = -1 + *ti;
		if (t & 0x80)
			t = max;

		*(ti++) = t;
	}
	while (t == max);
}
#endif
