/*
    This file is part of COMMON AVR UTILS.

    COMMON AVR UTILS is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License (LGPL)
    as published by the Free Software Foundation, either version 3 of
    the License, or (at your option) any later version.

    COMMON AVR UTILS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License at <http://www.gnu.org/licenses/>
    for more details.

    (C) Georg-Johann Lay <georgjohann@web.de>
*/

#ifndef TIME_H
#define TIME_H

#include <stdint.h>

#define TIMEID_MAX ((long) 60*60*12)

typedef struct
{
	struct 
	{
		uint8_t second;               
		uint8_t minute;             //  7
		uint8_t hour;               //  6
		uint8_t day_of_week;        //  3
		uint8_t day;                //  6
		uint8_t month;              //  5
		uint8_t year;               //  8
	};
    
    long timeid;
    
    struct
    {
        uint8_t second;
        uint8_t milli_second;
    } changed;
	
} time_t;

extern time_t time;
extern void next_second (time_t*);
//extern void prev_second (time_t*);

extern void timeid_add (time_t*, short inc);

#endif /* TIME_H */
